<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content controller">
                   <div class="content-data">





<ol class="breadcrumb">
  <li>Controllers</li>
  <li>NotificationGateway</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/routes/notification/notification.gateway.ts</code>
        </p>

            <p class="comment">
                <h3>Prefix</h3>
            </p>
            <p class="comment">
                <code>notification-gateway</code>
            </p>





            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#notifyEvent">notifyEvent</a>
                            </li>
                            <li>
                                <a href="#onNotificationsCount">onNotificationsCount</a>
                            </li>
                            <li>
                                <a href="#onPushData">onPushData</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="notifyEvent"></a>
                    <span class="name">
                        <b>
                            notifyEvent
                        </b>
                        <a href="#notifyEvent"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>notifyEvent(data: <a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank">any</a>)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@EventPattern(&#x27;notification2&#x27;)<br /></code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="54"
                            class="link-to-prism">src/routes/notification/notification.gateway.ts:54</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>data</td>
                                    <td>
                                                <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="onNotificationsCount"></a>
                    <span class="name">
                        <b>
                            onNotificationsCount
                        </b>
                        <a href="#onNotificationsCount"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>onNotificationsCount(data: <a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank">any</a>, client: Socket)</code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Decorators : </b>
                    <br />
                    <code>@SubscribeMessage(&#x27;notification-count&#x27;)<br /></code>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="61"
                            class="link-to-prism">src/routes/notification/notification.gateway.ts:61</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>data</td>
                                    <td>
                                                <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>client</td>
                                    <td>
                                            <code>Socket</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Observable&lt;WsResponse&lt;number&gt;&gt;</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="onPushData"></a>
                    <span class="name">
                        <b>
                            onPushData
                        </b>
                        <a href="#onPushData"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>onPushData()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="49"
                            class="link-to-prism">src/routes/notification/notification.gateway.ts:49</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { InjectQueue } from &#x27;@nestjs/bull&#x27;
import { Controller, Logger } from &#x27;@nestjs/common&#x27;
import { EventPattern } from &#x27;@nestjs/microservices&#x27;
import { ConnectedSocket, MessageBody, SubscribeMessage, WebSocketGateway, WebSocketServer, WsResponse } from &#x27;@nestjs/websockets&#x27;
import { Queue } from &#x27;bull&#x27;
import { ObjectId } from &#x27;mongodb&#x27;
import { from, Observable } from &#x27;rxjs&#x27;
import { map } from &#x27;rxjs/operators&#x27;
import { Server, Socket } from &#x27;socket.io&#x27;

@Controller(&#x27;notification-gateway&#x27;)
@WebSocketGateway()
export class NotificationGateway {
  @WebSocketServer()
  server: Server

  private readonly logger &#x3D; new Logger(NotificationGateway.name)
  // private sockets: ISocket[] &#x3D; []

  constructor(
    // @InjectQueue(&#x27;&#x27;)
    // private readonly notificationQueue: Queue&lt;any&gt;
  ) { }

  // @SubscribeMessage(&#x27;message&#x27;)
  // handleMessage(client: Socket, payload: any): string {
  //   return &#x27;Hello world!&#x27;;
  // }

  // @SubscribeMessage(&#x27;connection&#x27;)
  // onConnection(
  //   @MessageBody() data: any,
  //   @ConnectedSocket() client: Socket,
  // ) {
  //   // TODO: Handle connection and connect user to room with &#x27;/user/&lt;user_id&gt;. since users can&#x27;t join from client it should work and since it shouldn&#x27;t be possible to join from client side.
  //   // TODO: Make the client join different rooms depending on functionality? OR if the client has to listen to a type sent from server to filter out the events sent back? Second probably better since we don&#x27;t need to have more rooms than necessary

  //   this.logger.debug(this.onConnection.name)
  //   console.log(data)
  //   let user_id &#x3D; &#x27;&#x27;
  //   client.join(&#x60;user/${user_id}&#x60;, () &#x3D;&gt; {
  //     this.logger.debug(&#x27;sending message to client&#x27;)
  //     // client.to(&#x60;user/${user_id}&#x60;).emit(&#x27;connection&#x27;, &#x27;Connected to room&#x27;)
  //     this.server.to(&#x60;user/${user_id}&#x60;).emit(&#x27;connected&#x27;, &#x27;Connected to room&#x27;)
  //     this.logger.debug(&#x27;sent message to client&#x27;)
  //   })
  // }

  onPushData() {
    this.server.to(&#x27;&#x27;).emit(&#x27;&#x27;, {})
  }

  @EventPattern(&#x27;notification2&#x27;)
  notifyEvent(data: any) {
    this.logger.debug(&#x27;n2&#x27;)
    console.log(data)
    return 2
  }

  @SubscribeMessage(&#x27;notification-count&#x27;)
  onNotificationsCount(
    @MessageBody() data: any,
    @ConnectedSocket() client: Socket,
  ): Observable&lt;WsResponse&lt;number&gt;&gt; {

    // TODO: See if microservice can push data here, and send to client? so that the client only has to have the connection open
    // TODO: See possibilities to listen on a queue with RxJS

    const event &#x3D; &#x27;notification-count&#x27;
    const response &#x3D; [1, 3, 2]

    client.to(&#x27;&#x27;).emit(event)
    this.server.sockets.to(&#x27;socket id?&#x27;).emit(&#x27;event name&#x27;)

    return from(response)
      .pipe(
        map(data &#x3D;&gt; ({ event, data }))
      )
  }
}
</code></pre>
    </div>
</div>









                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'controller';
            var COMPODOC_CURRENT_PAGE_URL = 'NotificationGateway.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
